char def_kbrd[] = "KEYBOARD";

struct
{
    unsigned char b001;
    unsigned char b000;
    unsigned char shift;
    unsigned char b001s;
    unsigned char b000s;
    unsigned char shifts;
} ak[] =
{                            /*  Pc   Atom   Key */
    0xFF,-1, 0, 0xFF,-1, 1,  /* 0x00, 0xFF,  NO! */
    0xDF, 0, 0, 0xDF, 0, 1,  /* 0x01, 0x3B,  Esc */
    0xFD, 2, 0, 0xFD, 2, 1,  /* 0x02, 0x11,  1   */
//    0xFD, 1, 0, 0xFD, 1, 1,  /* 0x03, 0x12,  2   */   LAPTOP !!
    0xFD, 1, 0, 0xF7, 7, 0,  /* 0x03, 0x12,  2   */
    0xFD, 0, 0, 0xFD, 0, 1,  /* 0x04, 0x13,  3   */
    0xFB, 9, 0, 0xFB, 9, 1,  /* 0x05, 0x14,  4   */
    0xFB, 8, 0, 0xFB, 8, 1,  /* 0x06, 0x15,  5   */
    0xFB, 7, 0, 0xFE, 5, 0,  /* 0x07, 0x16,  6   */
    0xFB, 6, 0, 0xFB, 7, 1,  /* 0x08, 0x17,  7   */
    0xFB, 5, 0, 0xFB, 3, 1,  /* 0x09, 0x18,  8   */
    0xFB, 4, 0, 0xFB, 5, 1,  /* 0x0A, 0x19,  9   */
    0xFD, 3, 0, 0xFB, 4, 1,  /* 0x0B, 0x10,  0   */
    0xFB, 0, 0, 0xFB, 0, 0,  /* 0x0C, 0x1D,  -   */
    0xFB, 0, 1, 0xFB, 2, 1,  /* 0x0D, 0x1A,  = + */
    0xFD, 4, 0, 0xFD, 4, 0,  /* 0x0E, 0x0F,  BS  */
//    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x0F, 0xFF,  Tab */  /* TAB => Copy Key */
    0xFD, 5, 0, 0xFD, 5, 0,  /* 0x0F, 0x0E,  Tab */
    0xEF, 0, 0, 0xEF, 0, 1,  /* 0x10, 0x31,  Q   */
    0xDF, 4, 0, 0xDF, 4, 1,  /* 0x11, 0x37,  W   */
    0xF7, 2, 0, 0xF7, 2, 1,  /* 0x12, 0x25,  E   */
    0xDF, 9, 0, 0xDF, 9, 1,  /* 0x13, 0x32,  R   */
    0xDF, 7, 0, 0xDF, 7, 1,  /* 0x14, 0x34,  T   */
    0xDF, 2, 0, 0xDF, 2, 1,  /* 0x15, 0x39,  Y   */
    0xDF, 6, 0, 0xDF, 6, 1,  /* 0x16, 0x35,  U   */
    0xEF, 8, 0, 0xEF, 8, 1,  /* 0x17, 0x29,  I   */
    0xEF, 2, 0, 0xEF, 2, 1,  /* 0x18, 0x2F,  O   */
    0xEF, 1, 0, 0xEF, 1, 1,  /* 0x19, 0x30,  P   */
    0xFE, 8, 0, 0xFE, 8, 1,  /* 0x1A, 0x01,  [   */
    0xFE, 6, 0, 0xFE, 6, 1,  /* 0x1B, 0xFF,  ]   */
    0xFD, 6, 0, 0xFD, 6, 0,  /* 0x1C, 0x0D,  CR  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x1D, 0xFF,  Ctrl*/
    0xF7, 6, 0, 0xF7, 6, 1,  /* 0x1E, 0x21,  A   */
    0xDF, 8, 0, 0xDF, 8, 1,  /* 0x1F, 0x33,  S   */
    0xF7, 3, 0, 0xF7, 3, 1,  /* 0x20, 0x24,  D   */
    0xF7, 1, 0, 0xF7, 1, 1,  /* 0x21, 0x26,  F   */
    0xF7, 0, 0, 0xF7, 0, 1,  /* 0x22, 0x27,  G   */
    0xEF, 9, 0, 0xEF, 9, 1,  /* 0x23, 0x28,  H   */
    0xEF, 7, 0, 0xEF, 7, 1,  /* 0x24, 0x2A,  J   */
    0xEF, 6, 0, 0xEF, 6, 1,  /* 0x25, 0x2B,  K   */
    0xEF, 5, 0, 0xEF, 5, 1,  /* 0x26, 0x2C,  L   */
    0xFB, 2, 0, 0xFB, 3, 0,  /* 0x27, 0x1B,  ;   */
//    0xFB, 6, 1, 0xF7, 7, 0,  /* 0x28, 0x20,  '   */   LAPTOP !!
    0xFB, 6, 1, 0xFD, 1, 1,  /* 0x28, 0x20,  '   */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x29, 0x1A,  `   */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x2A, 0xFF,  ShfL*/
//    0xFD, 0, 1, 0xFE, 5, 1,  /* 0x2B, 0x02,  e# (\) */    LAPTOP !!
    0xFE, 7, 0, 0xFE, 7, 1,  /* 0x2B, 0xFF,  \ | */
    0xDF, 1, 0, 0xDF, 1, 1,  /* 0x2C, 0x3A,  Z   */
    0xDF, 3, 0, 0xDF, 3, 1,  /* 0x2D, 0x38,  X   */
    0xF7, 4, 0, 0xF7, 4, 1,  /* 0x2E, 0x23,  C   */
    0xDF, 5, 0, 0xDF, 5, 1,  /* 0x2F, 0x36,  V   */
    0xF7, 5, 0, 0xF7, 5, 1,  /* 0x30, 0x22,  B   */
    0xEF, 3, 0, 0xEF, 3, 1,  /* 0x31, 0x2E,  N   */
    0xEF, 4, 0, 0xEF, 4, 1,  /* 0x32, 0x2D,  M   */
    0xFB, 1, 0, 0xFB, 1, 1,  /* 0x33, 0x1C,  ,   */
    0xF7, 9, 0, 0xF7, 9, 1,  /* 0x34, 0x1E,  .   */
    0xF7, 8, 0, 0xF7, 8, 1,  /* 0x35, 0x1F,  /   */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x36, 0xFF,  ShfR*/
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x37, 0xFF,  *   */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x38, 0xFF,  Alt */
    0xFE, 9, 0, 0xFE, 9, 1,  /* 0x39, 0x00,  Spc */
    0xFE, 4, 0, 0xFE, 4, 1,  /* 0x3A, 0x05,  Caps*/
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x3B, 0xFF,  F1  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x3C, 0xFF,  F2  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x3D, 0xFF,  F3  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x3E, 0xFF,  F4  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x3F, 0xFF,  F5  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x40, 0xFF,  F6  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x41, 0xFF,  F7  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x42, 0xFF,  F8  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x43, 0xFF,  F9  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x44, 0xFF,  F10 */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x45, 0xFF,  NumL*/
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x46, 0xFF,  ScrL*/
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x47, 0xFF,  Home*/
    0xFE, 2, 0, 0xFE, 2, 0,  /* 0x48, 0x07,  CUp */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x49, 0xFF,  PgUp*/
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x4A, 0xFF,  [-] */
    0xFE, 3, 1, 0xFE, 3, 1,  /* 0x4B, 0x06,  <-  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x4C, 0xFF,  [5] */
    0xFE, 3, 0, 0xFE, 3, 0,  /* 0x4D, 0x06,  ->  */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x4E, 0xFF,  [+] */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x4F, 0xFF,  End */
    0xFE, 2, 1, 0xFE, 2, 1,  /* 0x50, 0x07,  CDn */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x51, 0xFF,  PgDn*/
    0xFD, 5, 0, 0xFD, 5, 0,  /* 0x52, 0x0E,  Ins */
    0xFD, 4, 0, 0xFD, 4, 0,  /* 0x53, 0x0F,  Del */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x54, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x55, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x56, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x57, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x58, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x59, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5A, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5B, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5C, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5D, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5E, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x5F, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x60, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x61, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x62, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x63, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x64, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x65, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x66, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x67, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x68, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x69, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6A, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6B, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6C, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6D, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6E, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x6F, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x70, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x71, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x72, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x73, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x74, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x75, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x76, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x77, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x78, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x79, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7A, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7B, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7C, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7D, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7E, 0xFF,      */
    0xFF,-1, 0, 0xFF,-1, 0,  /* 0x7F, 0xFF       */
};
